<%@ Page language="C#" %>
<%@ Import Namespace="System.Text" %>
<html>
	<head>
		<script language="C#" runat="server">

    private string ConvertBase(int dec)
    {
      StringBuilder sb = new StringBuilder();
      sb.Append("Binary: " + Convert.ToString(dec, 2) + "<br />");
      sb.Append("Octal: " + Convert.ToString(dec, 8) + "<br />");
      sb.Append("Decimal: " + Convert.ToString(dec, 10) + "<br />");
      sb.Append("Hexadecimal: " + Convert.ToString(dec, 16) + "<br />");
      return sb.ToString();
    }

    private void ConvertNumber_Click(object sender, System.EventArgs e)
    {
      string input = Input.Text;
      int dec = 0;
      try
      {
        if (Binary.Checked)
        {
          dec = Convert.ToInt32(input, 2);
        }
        if (Octal.Checked)
        {
          dec = Convert.ToInt32(input, 8);
        }
        if (Decimal.Checked)
        {
          dec = Convert.ToInt32(input);
        }
        if (Hexadecimal.Checked)
        {
          dec = Convert.ToInt32(input, 16);
        }
        Output.Text = ConvertBase(dec);
      }
      catch(Exception ex)
      {
        Output.Text = "Error: " + ex.Message;
      }

    }
		</script>
		<title>Convert Number</title>
	</head>
	<body>
		<form id="ConvertBases" method="post" runat="server">
			<p>
				<table id="Table1" cellSpacing="1" cellPadding="1">
					<tr>
						<td>
							<p>
								<asp:TextBox id="Input" runat="server"></asp:TextBox></p>
							<p>
								<asp:Button id="ConvertNumber" runat="server" Text="Convert" OnClick="ConvertNumber_Click"></asp:Button></p>
						</td>
						<td valign="top">
							<asp:RadioButton id="Binary" Text="Binary" GroupName="Bases" runat="server"></asp:RadioButton><br />
							<asp:RadioButton id="Octal" Text="Octal" GroupName="Bases" runat="server"></asp:RadioButton><br />
							<asp:RadioButton id="Decimal" Text="Decimal" Checked="True" GroupName="Bases" runat="server"></asp:RadioButton><br />
							<asp:RadioButton id="Hexadecimal" Text="Hexadecimal" GroupName="Bases" runat="server"></asp:RadioButton>
						</td>
					</tr>
					<tr>
						<td colspan="2">&nbsp;</td>
					</tr>
					<tr>
						<td colspan="2">
							<p>
								<asp:Label id="Output" runat="server"></asp:Label></p>
						</td>
					</tr>
				</table>
			</p>
		</form>
	</body>
</html>
