<%@ Page %>
<script language="C#" runat="server">
private void Page_Load(object sender, System.EventArgs e)
{
	// Formatting DateTime variables
	// Using DateTime methods
	Response.Write("Default: " + System.DateTime.Now + "<br>");
	Response.Write("Local Time: " + System.DateTime.Now.ToLocalTime() + "<br>");
	Response.Write("Long Date: " + System.DateTime.Now.ToLongDateString() + "<br>");
	Response.Write("Long Time: " + System.DateTime.Now.ToLongTimeString() + "<br>");
	Response.Write("Short Date: " + System.DateTime.Now.ToShortDateString() + "<br>");
	Response.Write("Short Time: " + System.DateTime.Now.ToShortTimeString() + "<br>");
	Response.Write("ToString Default: " + System.DateTime.Now.ToString() + "<br>");
	Response.Write("Universal Time: " + System.DateTime.Now.ToUniversalTime() + "<br>"); // returns a datetime, which can still be formatted
	
	// Using Format Strings
	Response.Write("d - Short Date: " + System.DateTime.Now.ToString("d") + "<br>");
	Response.Write("D - Long Date: " + System.DateTime.Now.ToString("D") + "<br>");
	Response.Write("t - Short Time: " + System.DateTime.Now.ToString("t") + "<br>");
	Response.Write("T - Long Time: " + System.DateTime.Now.ToString("T") + "<br>");
	Response.Write("f - Full date/time (short time): " + System.DateTime.Now.ToString("f") + "<br>");
	Response.Write("F - Full date/time (long time): " + System.DateTime.Now.ToString("F") + "<br>");
	Response.Write("g - General: " + System.DateTime.Now.ToString("g") + "<br>");
	Response.Write("G - General: " + System.DateTime.Now.ToString("G") + "<br>");
	Response.Write("M/m - Month day: " + System.DateTime.Now.ToString("M") + "<br>");
	Response.Write("u - Universal Sortable: " + System.DateTime.Now.ToString("u") + "<br>");
	Response.Write("Y/y - Year month: " + System.DateTime.Now.ToString("y") + "<br>");

	// Custom Format Strings
	Response.Write("d, day of month: " + System.DateTime.Now.ToString(" d") + "<br>"); // can't use just "d"
	Response.Write("dd, zero-padded day of month: " + System.DateTime.Now.ToString("dd") + "<br>");
	Response.Write("ddd, abbreviated day of week: " + System.DateTime.Now.ToString("ddd") + "<br>");
	Response.Write("dddd, full day of week: " + System.DateTime.Now.ToString("dddd") + "<br>");

	Response.Write("h, hour: " + System.DateTime.Now.ToString(" h") + "<br>"); // can't use just "h"
	Response.Write("hh, hour, zero padded " + System.DateTime.Now.ToString("hh") + "<br>");
	Response.Write("H, hour, 24-hr " + System.DateTime.Now.ToString(" H") + "<br>"); // can't use just "H"
	Response.Write("H, hour, 24-hr, zero padded " + System.DateTime.Now.ToString("HH") + "<br>");
	
	Response.Write("m, minute: " + System.DateTime.Now.ToString(" m") + "<br>"); // can't use just "m"
	Response.Write("M, month: " + System.DateTime.Now.ToString(" M") + "<br>"); // can't use just "M"
	Response.Write("MM, month, zero padded: " + System.DateTime.Now.ToString("MM") + "<br>"); 
	Response.Write("MMM, month abbreviated: " + System.DateTime.Now.ToString("MMM") + "<br>"); 
	Response.Write("MMMM, month full name: " + System.DateTime.Now.ToString("MMMM") + "<br>"); 
	
	Response.Write("y, year (omits century): " + System.DateTime.Now.ToString(" y") + "<br>"); // can't use just "y"
	Response.Write("yy, 2-digit year, zero padded: " + System.DateTime.Now.ToString("yy") + "<br>"); 
	Response.Write("yyyy, 4-digit year, zero padded: " + System.DateTime.Now.ToString("yyyy") + "<br>"); 
}
</script>
