<%@ Page Language="C#" %>
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Text" %>
<script language="C#" runat="server">
    protected void Page_Load (object Source, EventArgs e)
    {
      RWords.Text = GetRWordsFromFile(Server.MapPath("starwarquotes.txt"));
    }

    public string GetRWordsFromFile(string filename)
    {
      StreamReader sr = null;
      char[] delimiter = {'\u0009',' '}; //tab and space
      StringBuilder sb = new StringBuilder();
      try
      {
        sr = File.OpenText(filename);
        string line = sr.ReadLine();
        while( line != null )
        {
          //split the line into words
          string[] words = line.Split(delimiter);
          foreach (string word in words)
          {
            if (word.EndsWith("r"))
            {
              sb.Append(word);
              sb.Append("<br>");
            }
          }
          line = sr.ReadLine();
        }
      }
      catch(Exception ex)
      {
        if (sb.Length > 0) sb.Remove(0,sb.Length-1);
        sb.Append(ex.Message);
      }
      finally
      {
        if (sr != null) sr.Close();
      }

      return sb.ToString();
    }
</script>
<html>
	<body>
		<form runat="server">
			<asp:Label id="RWords" runat="server" />
			<hr>
			<a href="starwarquotes.txt">Quotes File</a>
		</form>
	</body>
</html>
