<%@ Page Language="C#" %>
<%@ Import Namespace="System.Collections" %>
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Text" %>
<script language="C#" runat="server">
string fileName = "";
  private void Page_Init()
  {
	fileName = Server.MapPath("starwarquotes.txt");
  }
  
  public string GetRandomizedLinesFromFile(string filename)
  {
    StreamReader sr = null;
    string result = string.Empty;
    ArrayList lines = new ArrayList();
    try
    {
      sr = File.OpenText(filename);
      string line = sr.ReadLine();
      while( line != null )
      {
        lines.Add(line);
        line = sr.ReadLine();
      }
    }
    catch(Exception ex)
    {
      result = ex.Message;
    }
    finally
    {
      if (sr != null) sr.Close();
    }

    //use GetRandomListOfInts to shuffle the order of lines
    int[] randInts = GetRandomListOfInts(lines.Count);
    StringBuilder sb = new StringBuilder();
    for (int i=0; i<randInts.Length; i++)
    {
      sb.Append(lines[randInts[i]] + "<br>");
    }
    
    result = sb.ToString();

    return result;
  }

  public string GetRandomizedWordsFromFile(string filename)
  {
    StreamReader sr = null;
    string result = string.Empty;
    char[] delimiter = {'\u0009',' '}; //tab and space
    ArrayList words = new ArrayList();
    try
    {
      sr = File.OpenText(filename);
      string line = sr.ReadLine();
      while( line != null )
      {
        //split the line into words
        string[] wordsInLine = line.Split(delimiter);
        foreach (string word in wordsInLine)
        {
          words.Add(word);
        }
        line = sr.ReadLine();
      }
    }
    catch(Exception ex)
    {
      result = ex.Message;
    }
    finally
    {
      if (sr != null) sr.Close();
    }

    //use GetRandomListOfInts to shuffle the order of words
    int[] randInts = GetRandomListOfInts(words.Count);
    StringBuilder sb = new StringBuilder();
    for (int i=0; i<randInts.Length; i++)
    {
      sb.Append(words[randInts[i]] + " ");
    }
    
    result = sb.ToString();

    return result;
  }

  public int[] GetRandomListOfInts(int ListLength)
  {
    //make a list of ints the length of parameter
    ArrayList listInOrder = new ArrayList();
    for (int i=0; i<ListLength; i++)
    {
      listInOrder.Add(i);
    }

    int[] randomNumbers = new int[ListLength];
    Random r = new Random();

    //shuffle the list of numbers
    for (int i=0; i<ListLength; i++)
    {
      int randomIndex = r.Next(listInOrder.Count);
      randomNumbers[i] = (int)listInOrder[randomIndex];
      listInOrder.RemoveAt(randomIndex);
    }

    return randomNumbers;
  }

  private void RandomizeWords_Click(object sender, System.EventArgs e)
  {
    Randomized.Text = GetRandomizedWordsFromFile(fileName);
  }

  private void RandomizeLines_Click(object sender, System.EventArgs e)
  {
    Randomized.Text = GetRandomizedLinesFromFile(fileName);
  }
</script>
<html>
	<body>
		<form runat="server">
			<asp:Button id="RandomizeWords" runat="server" Text="Randomize Words" OnClick="RandomizeWords_Click"></asp:Button>&nbsp;
			<asp:Button id="RandomizeLines" runat="server" Text="Randomize Lines" OnClick="RandomizeLines_Click"></asp:Button>
			<br>
			<asp:Label id="Randomized" runat="server" />
			<hr>
			<a href="starwarquotes.txt">Quotes File</a>
		</form>
	</body>
</html>
