<%@ Page Language="VB" %>
<%@ Import Namespace="System.Collections" %>
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Text" %>
<script language="VB" runat="server">
  Dim fileName As String = Server.MapPath("starwarquotes.txt")
  
  Public Function GetRandomizedLinesFromFile(filename As String) As String
     Dim sr As StreamReader = Nothing
     Dim result As String = String.Empty
     Dim lines As New ArrayList()
     Try
        sr = File.OpenText(filename)
        Dim line As String = sr.ReadLine()
        While Not (line Is Nothing)
           lines.Add(line)
           line = sr.ReadLine()
        End While
     Catch ex As Exception
        result = ex.Message
     Finally
        If Not (sr Is Nothing) Then
           sr.Close()
        End If
     End Try 
     'use GetRandomListOfInts to shuffle the order of lines
     Dim randInts As Integer() = GetRandomListOfInts(lines.Count)
     Dim sb As New StringBuilder()
     Dim i As Integer
     For i = 0 To randInts.Length - 1
        sb.Append((lines(randInts(i)) + "<br>"))
     Next i

     result = sb.ToString()

     Return result
  End Function


  Public Function GetRandomizedWordsFromFile(filename As String) As String
     Dim sr As StreamReader = Nothing
     Dim result As String = String.Empty
     Dim delimiter As Char() =  {ControlChars.Tab, " "c} 'tab and space
     Dim words As New ArrayList()
     Try
        sr = File.OpenText(filename)
        Dim line As String = sr.ReadLine()
        While Not (line Is Nothing)
           'split the line into words
           Dim wordsInLine As String() = line.Split(delimiter)
           Dim word As String
           For Each word In  wordsInLine
              words.Add(word)
           Next word
           line = sr.ReadLine()
        End While
     Catch ex As Exception
        result = ex.Message
     Finally
        If Not (sr Is Nothing) Then
           sr.Close()
        End If
     End Try 
     'use GetRandomListOfInts to shuffle the order of words
     Dim randInts As Integer() = GetRandomListOfInts(words.Count)
     Dim sb As New StringBuilder()
     Dim i As Integer
     For i = 0 To randInts.Length - 1
        sb.Append((words(randInts(i)) + " "))
     Next i

     result = sb.ToString()

     Return result
  End Function


  Public Function GetRandomListOfInts(ListLength As Integer) As Integer()
     'make a list of ints the length of parameter
     Dim listInOrder As New ArrayList()
     Dim i As Integer
     For i = 0 To ListLength - 1
        listInOrder.Add(i)
     Next i

     Dim randomNumbers(ListLength) As Integer
     Dim r As New Random()

     'shuffle the list of numbers
     Dim j As Integer
     For j = 0 To ListLength - 1
        Dim randomIndex As Integer = r.Next(listInOrder.Count)
        randomNumbers(j) = CInt(listInOrder(randomIndex))
        listInOrder.RemoveAt(randomIndex)
     Next j

     Return randomNumbers
  End Function
 
  Private  Sub RandomizeWords_Click(ByVal sender As Object, ByVal e As System.EventArgs)
    Randomized.Text = GetRandomizedWordsFromFile(fileName)
  End Sub
 
  Private  Sub RandomizeLines_Click(ByVal sender As Object, ByVal e As System.EventArgs)
    Randomized.Text = GetRandomizedLinesFromFile(fileName)
  End Sub
</script>
<html>
	<body>
		<form runat="server">
			<asp:Button id="RandomizeWords" runat="server" Text="Randomize Words" OnClick="RandomizeWords_Click"></asp:Button>&nbsp;
			<asp:Button id="RandomizeLines" runat="server" Text="Randomize Lines" OnClick="RandomizeLines_Click"></asp:Button>
			<br>
			<asp:Label id="Randomized" runat="server" />
			<hr>
			<a href="starwarquotes.txt">Quotes File</a>
		</form>
	</body>
</html>
