<%@ Import Namespace="System" %>
<%@ Import Namespace="System.IO" %>
<%@ Page Language="C#" %>
<script runat="server">

    void Page_Load(Object Source, EventArgs E)
    {    
		// Remove the next two lines to enable
		Response.Write("Disabled for security reasons");
		Response.End();
		
        if (!(Page.IsPostBack))
		{
            String Drive;
            String[] Drives;
    
	    //Assigns all logical drives of the system to the array
            Drives = Directory.GetLogicalDrives();
    
	    //Bind the collection to the dropdownlist control
            DriveDisplay.DataSource = Drives;
            DriveDisplay.DataBind();
        }
        
        SearchResultsLiteral.Text = "";
    
    }
    
    public void Search_Click(Object Source, EventArgs E)
    {
        if (CriteriaTextBox.Text != "")
	{
           //Assign the search criteria to the declared variable
           String Criteria = CriteriaTextBox.Text;
    
	   //Assign the selected drive letter in dropdownlist to the global variable
           String DriveRoot = DriveDisplay.SelectedItem.Text;
           String[] Directories , Files;
    
           Directories  = Directory.GetDirectories(DriveRoot);
           Files = Directory.GetFileSystemEntries(DriveRoot, Criteria);
    
           BeginTable();
    
           foreach (String iDirectory in Directories )
	   	   {
              Search(iDirectory, Criteria);
           }
    
           foreach (String iFile in Files)
	       {
              ListFiles(iFile);
           }
    
           EndTable();
	}
        else
           SearchResultsLiteral.Text = "Enter a search criteria.";
    }
    
    //Formats the output of the filenames
    public void ListFiles(String FileName)
    {
        FileInfo iFileInfo = new FileInfo(FileName);
    
        SearchResultsLiteral.Text += "<Tr>";
        SearchResultsLiteral.Text += "<Td>" + iFileInfo.Name + "</Td>";
        SearchResultsLiteral.Text += "<Td><a href='" + Path.GetDirectoryName(iFileInfo.FullName) + "'>" + Path.GetDirectoryName(iFileInfo.FullName) + "</a></Td>";
        if(Path.HasExtension(FileName))
           SearchResultsLiteral.Text += "<Td>" + iFileInfo.Extension + "</Td>";
        else
           SearchResultsLiteral.Text += "<Td> Dir </Td>";

        SearchResultsLiteral.Text += "<Td>" + iFileInfo.LastWriteTime + "</Td>";
        SearchResultsLiteral.Text += "</Tr>";
    }
    
    //Iteration carried out to search within directories
    private void Search(String Dir, String Cri)
    {
        String[] Directories , Files;
    
        Directories  = Directory.GetDirectories(Dir);
        Files = Directory.GetFileSystemEntries(Dir, Cri);
    
        foreach (String iDirectory in Directories )
            Search(iDirectory, Cri);
    
        foreach (String iFile in Files)
            ListFiles(iFile);
    }
    
    //Method creates the header of the output table
    public void BeginTable()
    {
        SearchResultsLiteral.Text += "<Table border='0' cellspacing='1' cellpadding='3'>";
        SearchResultsLiteral.Text += "<Th bgcolor='#C6C6C6'> Name </Th>";
        SearchResultsLiteral.Text += "<Th bgcolor='#C6C6C6'> Path </Th>";
        SearchResultsLiteral.Text += "<Th bgcolor='#C6C6C6'> Extension </Th>";
        SearchResultsLiteral.Text += "<Th bgcolor='#C6C6C6'> Modified On</Th>";
    }    
    
    //Method creates the closing of the output table
    public void EndTable()
    {
    	SearchResultsLiteral.Text += "</Table>";
    }

</script>
<html>
	<head>
		<title>File Search Utility</title>
	</head>
	<body>
		<form runat="server">
			<h4>Type Path/Name of file to search for it
			</h4>
			<p>
				<asp:TextBox id="CriteriaTextBox" runat="server"></asp:TextBox>
				&nbsp;<asp:Button id="SearchButton" runat="server" Text="Search" onclick="Search_Click"></asp:Button>
			</p>
			<p>
				<asp:DropDownList id="DriveDisplay" runat="server"></asp:DropDownList>
			</p>
			<p>
				<hr />
			</p>
			<p>
			</p>
			<p>
			</p>
			<p>
			</p>
			<p>
			</p>
			<p>
			</p>
			<p>
			</p>
			<p>
				<asp:Literal id="SearchResultsLiteral" runat="server"></asp:Literal>
			</p>
		</form>
	</body>
</html>
