<%@ Page Language="C#" %>
<%@ Import Namespace="System.Drawing" %>
<%@ Import Namespace="System.Drawing.Drawing2D" %>
<%@ Import Namespace="System.Drawing.Imaging" %>
<script language="C#" runat="server">
private void Page_Load(object sender, System.EventArgs e)
{
	if (Request.QueryString["action"] == "blur")
		BlurImage();
	else if (Request.QueryString["action"] == "sharpen")
		SharpenImage();
	else
		Response.Write("Add ?action=blur to url to see blurred image.  Add ?action=sharpen to sharpen image.");
}

private void BlurImage()
{
	Bitmap outputBitmap = new Bitmap( Server.MapPath("Recipe2208.jpg") );
	int repetitions = 5;
	int red = 0;
	int green = 0;
	int blue = 0;

	for (int i = 0; i < repetitions; i++)
	{
		for (int x = 1; x < (outputBitmap.Width - 1); x++)
		{
			for (int y = 1; y < (outputBitmap.Height - 1); y++)
			{
				red += outputBitmap.GetPixel(x, y - 1).R;
				red += outputBitmap.GetPixel(x, y + 1).R;
				red += outputBitmap.GetPixel(x, y).R;
				red += outputBitmap.GetPixel(x + 1, y).R;
				red += outputBitmap.GetPixel(x - 1, y).R;
				red = red / 5;

				green += outputBitmap.GetPixel(x, y - 1).G;
				green += outputBitmap.GetPixel(x, y + 1).G;
				green += outputBitmap.GetPixel(x, y).G;
				green += outputBitmap.GetPixel(x + 1, y).G;
				green += outputBitmap.GetPixel(x - 1, y).G;
				green = green / 5;

				blue += outputBitmap.GetPixel(x, y - 1).B;
				blue += outputBitmap.GetPixel(x, y + 1).B;
				blue += outputBitmap.GetPixel(x, y).B;
				blue += outputBitmap.GetPixel(x + 1, y).B;
				blue += outputBitmap.GetPixel(x - 1, y).B;
				blue = blue / 5;

				outputBitmap.SetPixel(x, y, Color.FromArgb( red, green, blue ));

				red = 0;
				green = 0;
				blue = 0;
			}
		}
	}

	Response.ContentType = "image/jpeg";
	outputBitmap.Save(Response.OutputStream, ImageFormat.Jpeg);
	outputBitmap.Dispose();
}

private void SharpenImage()
{
	Bitmap outputBitmap = new Bitmap( Server.MapPath("sample.jpg") );
	int repetitions = 1;
	int red = 0;
	int green = 0;
	int blue = 0;

	for (int i = 0; i < repetitions; i++)
	{
		for (int x = 3; x < (outputBitmap.Width - 3); x++)
		{
			for (int y = 3; y < (outputBitmap.Height - 3); y++)
			{
				// red
				red += -1 * outputBitmap.GetPixel(x + 1, y + 1).R;
				red += -2 * outputBitmap.GetPixel(x, y - 1).R;
				red += -1 * outputBitmap.GetPixel(x + 1, y - 1).R;
				red += -2 * outputBitmap.GetPixel(x - 1, y).R;
				red += 16 * outputBitmap.GetPixel(x, y).R;
				red += -2 * outputBitmap.GetPixel(x + 1, y).R; 
				red += -1 * outputBitmap.GetPixel(x - 1, y + 1).R;
				red += -2 * outputBitmap.GetPixel(x, y + 1).R;
				red += -1 * outputBitmap.GetPixel(x + 1, y + 1).R;
				red = red / 4;
				if (red > 255) red = 255;
				if (red < 0) red = 0;

				// green
				green += -1 * outputBitmap.GetPixel(x + 1, y + 1).G;
				green += -2 * outputBitmap.GetPixel(x, y - 1).G;
				green += -1 * outputBitmap.GetPixel(x + 1, y - 1).G;
				green += -2 * outputBitmap.GetPixel(x - 1, y).G;
				green += 16 * outputBitmap.GetPixel(x, y).G;
				green += -2 * outputBitmap.GetPixel(x + 1, y).G; 
				green += -1 * outputBitmap.GetPixel(x - 1, y + 1).G;
				green += -2 * outputBitmap.GetPixel(x, y + 1).G;
				green += -1 * outputBitmap.GetPixel(x + 1, y + 1).G;
				green = green / 4;
				if (green > 255) green = 255;
				if (green < 0) green = 0;

				// blue
				blue += -1 * outputBitmap.GetPixel(x + 1, y + 1).B;
				blue += -2 * outputBitmap.GetPixel(x, y - 1).B;
				blue += -1 * outputBitmap.GetPixel(x + 1, y - 1).B;
				blue += -2 * outputBitmap.GetPixel(x - 1, y).B;
				blue += 16 * outputBitmap.GetPixel(x, y).B;
				blue += -2 * outputBitmap.GetPixel(x + 1, y).B; 
				blue += -1 * outputBitmap.GetPixel(x - 1, y + 1).B;
				blue += -2 * outputBitmap.GetPixel(x, y + 1).B;
				blue += -1 * outputBitmap.GetPixel(x + 1, y + 1).B;
				blue = blue / 4;
				if (blue > 255) blue = 255;
				if (blue < 0) blue = 0;

				outputBitmap.SetPixel(x, y, Color.FromArgb( red, green, blue ));

				red = 0;
				green = 0;
				blue = 0;
			}
		}
	}

	Response.ContentType = "image/jpeg";
	outputBitmap.Save(Response.OutputStream, ImageFormat.Jpeg);
	outputBitmap.Dispose();
}
</script>
