<%@ Page language="VB" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Text" %>
<%@ Import Namespace="System.Reflection" %>
<script language="VB" runat="server">
    Private Sub ShowConstructors(ByVal type As Type)
      Dim constructorsTable As DataTable = New DataTable()
      constructorsTable.Columns.Add("Constructor", type.GetType("System.String"))
      constructorsTable.Columns.Add("Parameters", type.GetType("System.String"))
      Dim constructors() As MemberInfo = type.GetConstructors()
      Dim constructor As ConstructorInfo
      For Each constructor In constructors
        Dim dr As DataRow = constructorsTable.NewRow()
        dr("Constructor") = constructor.DeclaringType.Name
        Dim sb As StringBuilder = New StringBuilder()
        Dim pi() As ParameterInfo = constructor.GetParameters()
        sb.Append("( ")
        Dim i As Integer
        For i = 0 To pi.Length - 1 Step i + 1
          If i > 0 Then
            sb.Append(", ")
          End If
          Dim p As ParameterInfo = pi(i)
          sb.Append(p.ParameterType.Name)
          sb.Append(" ")
          sb.Append(p.Name)
        Next
        sb.Append(" )")
        dr("Parameters") = sb.ToString()
        constructorsTable.Rows.Add(dr)
      Next
      Dim constructorsView As DataView = constructorsTable.DefaultView
      constructorsView.Sort = "Constructor"
      ConstructorsGrid.DataSource = constructorsView
      ConstructorsGrid.DataBind()
    End Sub

    Private Sub ShowFields(ByVal type As Type)
      Dim fieldsTable As DataTable = New DataTable()
      fieldsTable.Columns.Add("Type", type.GetType("System.String"))
      fieldsTable.Columns.Add("FieldName", type.GetType("System.String"))
      Dim fields() As MemberInfo = type.GetFields()
      Dim field As FieldInfo
      For Each field In fields
        Dim dr As DataRow = fieldsTable.NewRow()
        dr("Type") = field.FieldType.Name
        dr("FieldName") = field.Name
        fieldsTable.Rows.Add(dr)
      Next
      Dim fieldsView As DataView = fieldsTable.DefaultView
      fieldsView.Sort = "FieldName"
      FieldsGrid.DataSource = fieldsView
      FieldsGrid.DataBind()
    End Sub

    Private Sub ShowProperties(ByVal type As Type)
      Dim propertiesTable As DataTable = New DataTable()
      propertiesTable.Columns.Add("Type", type.GetType("System.String"))
      propertiesTable.Columns.Add("PropertyName", type.GetType("System.String"))
      Dim properties() As MemberInfo = type.GetProperties()
      Dim property1 As PropertyInfo
      For Each property1 In properties
        Dim dr As DataRow = propertiesTable.NewRow()
        dr("Type") = property1.PropertyType.Name
        dr("PropertyName") = property1.Name
        propertiesTable.Rows.Add(dr)
      Next
      Dim propertiesView As DataView = propertiesTable.DefaultView
      propertiesView.Sort = "PropertyName"
      PropertiesGrid.DataSource = propertiesView
      PropertiesGrid.DataBind()
    End Sub

    Private Sub ShowMethods(ByVal type As Type)
      Dim methodsTable As DataTable = New DataTable()
      methodsTable.Columns.Add("ReturnType", type.GetType("System.String"))
      methodsTable.Columns.Add("MethodName", type.GetType("System.String"))
      methodsTable.Columns.Add("Parameters", type.GetType("System.String"))
      Dim methods() As MethodInfo = type.GetMethods()
      Dim method As MethodInfo
      For Each method In methods
        Dim dr As DataRow = methodsTable.NewRow()
        dr("ReturnType") = method.ReturnType.Name
        dr("MethodName") = method.Name
        Dim sb As StringBuilder = New StringBuilder()
        Dim pi() As ParameterInfo = method.GetParameters()
        sb.Append("( ")
        Dim i As Integer
        For i = 0 To pi.Length - 1 Step i + 1
          If i > 0 Then
            sb.Append(", ")
          End If
          Dim p As ParameterInfo = pi(i)
          sb.Append(p.ParameterType.Name)
          sb.Append(" ")
          sb.Append(p.Name)
        Next
        sb.Append(" )")
        dr("Parameters") = sb.ToString()
        methodsTable.Rows.Add(dr)
      Next
      Dim methodsView As DataView = methodsTable.DefaultView
      methodsView.Sort = "MethodName, Parameters"
      MethodsGrid.DataSource = methodsView
      MethodsGrid.DataBind()
    End Sub

    Private Sub RetrieveInfo_Click(ByVal sender As Object, ByVal e As System.EventArgs)
      Dim selectedClass As String = ListOfClass.SelectedItem.Value
      OutputClass.Text = selectedClass
      Dim type As Type = type.GetType(selectedClass)
      ShowConstructors(type)
      ShowFields(type)
      ShowProperties(type)
      ShowMethods(type)
    End Sub
</script>
<html>
	<head>
		<title>Reflect Class</title>
	</head>
	<body>
		<form id="ReflectClass" method="post" runat="server">
			<table cellSpacing="1" cellPadding="1">
				<tr>
					<td vAlign="top"><asp:button id="RetrieveInfo" onclick="RetrieveInfo_Click" runat="server" Text=" Retrieve Class Info "></asp:button></td>
					<td vAlign="top"><asp:radiobuttonlist id="ListOfClass" runat="server">
							<asp:ListItem Value="System.String"></asp:ListItem>
							<asp:ListItem Value="System.Double"></asp:ListItem>
							<asp:ListItem Value="System.DateTime"></asp:ListItem>
							<asp:ListItem Value="System.Collections.ArrayList"></asp:ListItem>
							<asp:ListItem Value="System.IO.StreamReader"></asp:ListItem>
						</asp:radiobuttonlist></td>
				</tr>
			</table>
			<br>
			<asp:label id="OutputClass" runat="server" Font-Bold="True" Font-Size="Larger"></asp:label><br>
			<br>
			<strong>Constructors</strong>
			<br>
			<asp:datagrid id="ConstructorsGrid" runat="server" BorderColor="#999999" BorderStyle="Solid" BorderWidth="1px" BackColor="White" CellPadding="3" GridLines="Vertical" ForeColor="Black">
				<AlternatingItemStyle BackColor="#CCCCCC"></AlternatingItemStyle>
				<HeaderStyle Font-Bold="True" ForeColor="White" BackColor="Black"></HeaderStyle>
			</asp:datagrid>
			<br>
			<strong>Fields</strong>
			<br>
			<asp:datagrid id="FieldsGrid" runat="server" BorderColor="#999999" BorderStyle="Solid" BorderWidth="1px" BackColor="White" CellPadding="3" GridLines="Vertical" ForeColor="Black">
				<AlternatingItemStyle BackColor="#CCCCCC"></AlternatingItemStyle>
				<HeaderStyle Font-Bold="True" ForeColor="White" BackColor="Black"></HeaderStyle>
			</asp:datagrid><br>
			<strong>Properties</strong>
			<br>
			<asp:datagrid id="PropertiesGrid" runat="server" BorderColor="#999999" BorderStyle="Solid" BorderWidth="1px" BackColor="White" CellPadding="3" GridLines="Vertical" ForeColor="Black">
				<AlternatingItemStyle BackColor="#CCCCCC"></AlternatingItemStyle>
				<HeaderStyle Font-Bold="True" ForeColor="White" BackColor="Black"></HeaderStyle>
			</asp:datagrid><br>
			<strong>Methods</strong>
			<br>
			<asp:datagrid id="MethodsGrid" runat="server" BorderColor="#999999" BorderStyle="Solid" BorderWidth="1px" BackColor="White" CellPadding="3" GridLines="Vertical" ForeColor="Black">
				<AlternatingItemStyle BackColor="#CCCCCC"></AlternatingItemStyle>
				<HeaderStyle Font-Bold="True" ForeColor="White" BackColor="Black"></HeaderStyle>
			</asp:datagrid>
		</form>
	</body>
</html>
